(*****************************************************************************

  Program:  Window extra demonstration

  Purpose:
    This program demonstrates the various abilities of the windows extention
    unit.

  Features:
    This program displays how the windows extention unit operates.

  Copyright 1994, All rights reserved.
    P. Renaud.

  Compilers:
    Turbo Pascal versions 4.0 to 6.0
    Speed Pascal/2 version 1.5

  Systems:
    MS-DOS, MDOS, OS/2

*****************************************************************************)

Program Window_Extra_Demonstration_Program( Input, Output );

  Uses
    CRT,
    Windows,
   {$IFNDEF OS2}
    WindExtra;
   {$ELSE}
    WindExtr;
   {$ENDIF}

  Var
    Counter: Word;
    Flag: Boolean;

  Begin;
    WriteLn( 'Windows extra demonstration program.' );
    WriteLn( 'Copyright 1994, All rights reserved.' );
    WriteLn( 'by P. Renaud.' );
    WriteLn;
    WriteLn( 'This program demonstrates the union of the WindExtra unit with the Windows' );
    WriteLn( 'unit.  To leave the demonstration click on the close box or press Escape.' );
    WriteLn;
    WriteLn( 'Please press [enter] to start.' );
    ReadLn;

    DirectVideo := True;

    TextAttr := Yellow_Character + Blue_Background;
   {$IFDEF OS2}
    TextBackground( TextAttr shr 4 );
   {$ENDIF}
    For Counter := 1 to 200 do
      Write( 'Background ' );

    If Open_Window( Frame_18, Window_Pop, 30, 8, 50, 18, $20 )
      then
        Begin
          If VW_Create( 19, 30 )
            then
              Begin
                For Counter := 1 to 50 do
                 {$IFNDEF OS2}
                  Write( VW, ' Virtual window ' );
                 {$ELSE}
                  Write( ' Normal window ' );
                 {$ENDIF}
                Add_Interface;
                VW_Browse;
              End;
          Close_Window( Window_Pop );
        End;

  End.

